#!/bin/bash

read  -p "Insert filename for load to MEM (default $loadbin):"  loadbinnew
read -p "Continue? (Y/N): " confirm && [[ $confirm == [yY] || $confirm == [yY][eE][sS] ]] || exit 1
if [ "$loadbinnew" == "" ]
then
echo  "FileName = " $loadbin >>.default
else
   loadbin="$loadbinnew"
echo  "FileName = " $loadbin >>.default
fi

writescript=$(basename $loadbin)".sh"

echo "WRITESCRIPT=$writescript"

read -p "Insert address to write:"  pradr
read -p "Insert bus address:" badr
read -p "Insert place to write 0 (boot) 1 (programm):" bp

echo "#!/bin/bash" >> $writescript
echo "" >> $writescript
echo "echo 'Start'" >> $writescript
echo "modprobe i2c-dev" >> $writescript
echo "modprobe i2c-i801" >> $writescript

crc1=$(crc32 $loadbin |awk '{print substr($0,1,2)}')
crc2=$(crc32 $loadbin |awk '{print substr($0,3,2)}')
crc3=$(crc32 $loadbin |awk '{print substr($0,5,2)}')
crc4=$(crc32 $loadbin |awk '{print substr($0,7,2)}')


xxd -g 1  $loadbin | cut -d':' -f2 | cut -d' '  -f1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17 | \
 awk -v wrh="\ni2cset -f -y $badr "0x"$pradr 0x8 " -v sl="\nsleep 0.01" '{ print  wrh"0x"$1,"0x"$2,"0x"$3,"0x"$4,"0x"$5,"0x"$6,"0x"$7,"0x"$8,"0x"$9,"0x"$10,"0x"$11,"0x"$12,"0x"$13,"0x"$14,"0x"$15,"0x"$16,"i",sl }'  >>$writescript

echo "i2cset -f -y $badr "0x"$pradr 0x8 "0x"$crc4" >> $writescript
echo "sleep 0.1" >> $writescript
echo "i2cset -f -y $badr "0x"$pradr 0x8 "0x"$crc3" >> $writescript
echo "sleep 0.1" >> $writescript
echo "i2cset -f -y $badr "0x"$pradr 0x8 "0x"$crc2" >> $writescript
echo "sleep 0.1" >> $writescript
echo "i2cset -f -y $badr "0x"$pradr 0x8 "0x"$crc1" >> $writescript
echo "sleep 0.1" >> $writescript

echo "echo 'Done'" >>$writescript
echo "sleep 0.1" >> $writescript
if [ "$bp" -eq 0 ]
then
echo "i2cset -f -y $badr "0x"$pradr 0xa 0xbb" >> $writescript
fi
if [ "$bp" -eq 1 ]
then
echo "i2cset -f -y $badr "0x"$pradr 0xa 0xaa" >> $writescript
fi
chmod +x $writescript

